#include "suarttx.h"
#include "settings.h"
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void sputchar(uint8_t c)                        // unsigned !
{
  c = ~c;                                       // complement to send 0 = stop bit(s)
  STXD_oe = 1;                                  // output
#if STX_CLI
  cli();  
#endif
  STXD = MARK;                                  // start bit
  for (uint8_t i = 9 + STOP_BITS; i; i--)       // start + data + stop bits
  {
    _delay_us(1e6 / BAUD);                      // bit duration
    if (c & 1)
      STXD = MARK;
    else
      STXD = !MARK;                             // = Space
    c >>= 1;                                    // next bits or stop bit(s)
  }
#if STX_CLI
  sei();  
#endif
}

void sputs(char* pt, uint8_t flag)
{
  uint8_t val;

  for (;;)
  {
    if (flag == TX_FLASH)
      val = pgm_read_byte(pt);
    else
      val = *pt;
    if (val == 0)
      return;
    sputchar(val);
    pt++;
  }
}
